'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const __chunk_1 = require('./chunk-92a5f172.js');

class Sticky {
    constructor(hostRef) {
        __chunk_1.registerInstance(this, hostRef);
        this.offset = 0;
        this.zIndex = 1;
    }
    stickySupported() {
        const ua = window.navigator.userAgent;
        const isIE = !~ua.indexOf('Trident');
        return isIE;
    }
    // TODO: Clean this function up
    polyfillSticky() {
        const elPosition = this.el.getBoundingClientRect().top;
        const elHeight = this.el.getBoundingClientRect().height;
        const nextEl = this.el.nextElementSibling;
        this.el.style.width = '100%';
        document.addEventListener('scroll', () => {
            if (window.pageYOffset >= elPosition - this.offset) {
                this.el.style.position = 'fixed';
                nextEl.style.marginTop = `${elHeight}px`;
            }
            else {
                this.el.style.position = 'static';
                nextEl.style.marginTop = `0px`;
            }
        });
    }
    componentDidLoad() {
        if (!this.stickySupported()) {
            this.polyfillSticky();
        }
    }
    render() {
        return (__chunk_1.h(__chunk_1.Host, { style: {
                top: `${this.offset}px`,
                zIndex: `${this.zIndex}`
            } }, __chunk_1.h("slot", null)));
    }
    get el() { return __chunk_1.getElement(this); }
    static get style() { return ".sc-ntara-sticky-h{position:-webkit-sticky;position:sticky;display:block}"; }
}

exports.ntara_sticky = Sticky;
