import { Host, h } from '@stencil/core';
export class Sticky {
    constructor() {
        this.offset = 0;
        this.zIndex = 1;
    }
    stickySupported() {
        const ua = window.navigator.userAgent;
        const isIE = !~ua.indexOf('Trident');
        return isIE;
    }
    // TODO: Clean this function up
    polyfillSticky() {
        const elPosition = this.el.getBoundingClientRect().top;
        const elHeight = this.el.getBoundingClientRect().height;
        const nextEl = this.el.nextElementSibling;
        this.el.style.width = '100%';
        document.addEventListener('scroll', () => {
            if (window.pageYOffset >= elPosition - this.offset) {
                this.el.style.position = 'fixed';
                nextEl.style.marginTop = `${elHeight}px`;
            }
            else {
                this.el.style.position = 'static';
                nextEl.style.marginTop = `0px`;
            }
        });
    }
    componentDidLoad() {
        if (!this.stickySupported()) {
            this.polyfillSticky();
        }
    }
    render() {
        return (h(Host, { style: {
                top: `${this.offset}px`,
                zIndex: `${this.zIndex}`
            } },
            h("slot", null)));
    }
    static get is() { return "ntara-sticky"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() { return {
        "$": ["ntara-sticky.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["ntara-sticky.css"]
    }; }
    static get properties() { return {
        "offset": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "offset",
            "reflect": false,
            "defaultValue": "0"
        },
        "zIndex": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "z-index",
            "reflect": false,
            "defaultValue": "1"
        }
    }; }
    static get elementRef() { return "el"; }
}
