import { r as registerInstance, h, H as Host, g as getElement } from './chunk-0433eeee.js';
var Sticky = /** @class */ (function () {
    function Sticky(hostRef) {
        registerInstance(this, hostRef);
        this.offset = 0;
        this.zIndex = 1;
    }
    Sticky.prototype.stickySupported = function () {
        var ua = window.navigator.userAgent;
        var isIE = !~ua.indexOf('Trident');
        return isIE;
    };
    // TODO: Clean this function up
    Sticky.prototype.polyfillSticky = function () {
        var _this = this;
        var elPosition = this.el.getBoundingClientRect().top;
        var elHeight = this.el.getBoundingClientRect().height;
        var nextEl = this.el.nextElementSibling;
        this.el.style.width = '100%';
        document.addEventListener('scroll', function () {
            if (window.pageYOffset >= elPosition - _this.offset) {
                _this.el.style.position = 'fixed';
                nextEl.style.marginTop = elHeight + "px";
            }
            else {
                _this.el.style.position = 'static';
                nextEl.style.marginTop = "0px";
            }
        });
    };
    Sticky.prototype.componentDidLoad = function () {
        if (!this.stickySupported()) {
            this.polyfillSticky();
        }
    };
    Sticky.prototype.render = function () {
        return (h(Host, { style: {
                top: this.offset + "px",
                zIndex: "" + this.zIndex
            } }, h("slot", null)));
    };
    Object.defineProperty(Sticky.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Sticky, "style", {
        get: function () { return ".sc-ntara-sticky-h{position:-webkit-sticky;position:sticky;display:block}"; },
        enumerable: true,
        configurable: true
    });
    return Sticky;
}());
export { Sticky as ntara_sticky };
