import { r as registerInstance, h, H as Host, g as getElement } from './chunk-0433eeee.js';

class Sticky {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.offset = 0;
        this.zIndex = 1;
    }
    stickySupported() {
        const ua = window.navigator.userAgent;
        const isIE = !~ua.indexOf('Trident');
        return isIE;
    }
    // TODO: Clean this function up
    polyfillSticky() {
        const elPosition = this.el.getBoundingClientRect().top;
        const elHeight = this.el.getBoundingClientRect().height;
        const nextEl = this.el.nextElementSibling;
        this.el.style.width = '100%';
        document.addEventListener('scroll', () => {
            if (window.pageYOffset >= elPosition - this.offset) {
                this.el.style.position = 'fixed';
                nextEl.style.marginTop = `${elHeight}px`;
            }
            else {
                this.el.style.position = 'static';
                nextEl.style.marginTop = `0px`;
            }
        });
    }
    componentDidLoad() {
        if (!this.stickySupported()) {
            this.polyfillSticky();
        }
    }
    render() {
        return (h(Host, { style: {
                top: `${this.offset}px`,
                zIndex: `${this.zIndex}`
            } }, h("slot", null)));
    }
    get el() { return getElement(this); }
    static get style() { return ".sc-ntara-sticky-h{position:-webkit-sticky;position:sticky;display:block}"; }
}

export { Sticky as ntara_sticky };
